{$A+,i-,v-,s-,f+,r-,O+}
{

   LZH.PAS - base unit for all Huffman engine components

   LZH.PAS based on:

   LZHUF.C English version 1.0 based on Japanese version 29-NOV-1988

   Haruhiko OKUMURA:   LZSS coded

   Haruyasu YOSHIZAKI: Adaptive Huffman Coding coded

   Kenji RIKITAKE:     Edited and translated to English

   Peter Sawatzki,

   Wayne Sullivan:     Converted to Turbo Pascal 5.0

   Joe Jared:          Assembler and Atari Port (12/16/92)

   Andres Cvitkovich:  object-oriented interface   (TP5.5+)

   <Your name here>: Other language interface.
}

unit LZH;
Interface
uses memory;
{$I lzh.inc}

type
  IObuf = array[0..$2800-1] of byte;

  LZHRec = Record       {Segment:0 aligned}
         WorkSpace1     : Array [0..N+F-1] of byte;
         count          : LongInt;
         textsize       : LongInt;
         codesize       : LongInt;
         inptr,inend,outptr,outend    : Word;
         Ebytes         : Longint;
         inbuf,outbuf        : IObuf;
         {Buffersize and position are critical}
         WorkSpace           : Array [0..$73ff] of byte;
         {LZHASM work space} {Some space reserved}
         End;

var
	LZHERROR    : Word; {for future use}
   	{$F+}
	WriteFromBuffer, ReadToBuffer: Procedure;
		{Assign your Procedures for IO handling to these routines}
	LZHMem: ^LZHRec;
	LZHMemSeg       : WORD;  {Seg(LZHMem)}
	{$F+}
	procedure Encode; { Compresses an incomming data stream }
	procedure Decode; { Decompresses an incomming data stream }

	Procedure InitLZH; { Initialization routines for Huffman compression engine }
	Procedure DInitLZH; { deinitialization routines for Huffman compression engine }
Implementation
{$F+}
 {$L LZHASM}
procedure Decode; External;
procedure Encode; External;

{$R-}
Procedure InitLZH;
Begin

	 lzhmem := memallocseg (Sizeof(LZhmem^));
	 LZHMemSeg := Seg(LZhmem^);
	 LZhmem^.Inend := 0;  { This is to insure that Read is called.      }
	 LZhmem^.outend := 0; { If you don't fill the input, the engine will}


End;
Procedure DInitLZH;
Begin
	 FreeMem (LZHMem,Sizeof(LZhmem^));
End;

end.
